/*
//  File  : cilk.c
//  (c)HOOPOE ProGroup 2011
*/

/*
// Cilk implementation in C=
*/

/// Copyright string
char* copyright = "(c)HOOPOE ProGroup 2011";

#include <stdio.h>
#include "cilk.h"

/// compute the Fibonacci number of order n
int fibonacci(int n)
{
    if(n < 2)
    {
        return n;
    }
    else
    {
        int x, y;
        int* shared xp = &x;

        cilk_spawn(*xp = fibonacci(n - 1));

        y = fibonacci(n - 2);

        cilk_sync;

        return x + y;
    }
}

char string[] = "CILK TEST PASSED";

void main()
{
    int order = 17;
    printf("Fibonacci[%d] = %d\n", order, fibonacci(order));

    cilk_for(int i, strlen(string), 1)
    {
        string[i] = string[i] == ' ' ? string[i] : string[i] | 0x20;
    }
    cilk_sync;

    printf("%s\n", string);
}
